package com.ibm.rational.report.oda.reqpro.ui;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;

import org.eclipse.core.runtime.Platform;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Image;
import org.eclipse.ui.internal.util.BundleUtility;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

import com.ibm.rational.report.oda.reqpro.ui.impl.ReqProDriverResourceBundle;

/**
 * The activator class controls the plug-in life cycle
 */

/**
 * @author Suryakant Choudhary
 * @since 1.0
 */
public class ReqProUIActivator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "com.ibm.rational.report.oda.reqpro.ui";

	// The shared instance
	private static ReqProUIActivator plugin;
	
	public static HashMap mUserInfo = null;
	
	/**
	 * The constructor
	 */
	public ReqProUIActivator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
		mUserInfo = new HashMap();
		
		
		// Load the Resource Bundle
		ReqProDriverResourceBundle.getResourceBundle();
		
		System.out.println("UI Plugin Started");
		
		//ImageDescriptor img = super.imageDescriptorFromPlugin(PLUGIN_ID, "icons/folder_c.gif");
		
		
		
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
		mUserInfo.clear();
		mUserInfo = null;
		System.out.println("UI Plugin Stopped");
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static ReqProUIActivator getDefault() {
		return plugin;
	}

	/**
	 * Returns an image descriptor for the image file at the given
	 * plug-in relative path
	 *
	 * @param path the path
	 * @return the image descriptor
	 */
	public static ImageDescriptor getImageDescriptor(String path) {
		return imageDescriptorFromPlugin(PLUGIN_ID, path);
	}
	
	/**
	 * Returns an image  for the image file at the given
	 * plug-in relative path
	 *
	 * @param path the path
	 * @return the image 
	 */
	public static Image getImage(String path)
	{
		return getImageDescriptor(path).createImage();
	}
	
	/**
	 * Returns the full path of the file at the given
	 * plug-in relative path
	 *
	 * @param relative path of the file
	 * @return Full path to the file 
	 */
	
	public static URL getFullFilePath(String path)  throws IllegalArgumentException
	{
		 if (PLUGIN_ID == null || path == null) {
	            throw new IllegalArgumentException();
	        }

	        // if the bundle is not ready then there is no image
	        Bundle bundle = Platform.getBundle(PLUGIN_ID);
	        if (!BundleUtility.isReady(bundle)) {
				return null;
			}

	        // look for the image (this will check both the plugin and fragment folders
	        URL fullPathString = BundleUtility.find(bundle, path);
	        
	        return fullPathString;
	}
}
