package com.ibm.rational.report.oda.reqpro.ui.impl;




import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;


import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;


import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridLayout;

import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Combo;

import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;

import org.xml.sax.helpers.DefaultHandler;

import com.ibm.rational.report.oda.reqpro.ui.ReqProUIActivator;

/**
 * @author Suryakant Choudhary
 * @since 1.0
 */

public class RESTDataSource extends Composite {

	//=====================  Flags and Variables =============================
	
	// ============= Flags for processing different project items ============
	protected static  int iFlag_Process = -1; 
	protected static final int iProject = 1;
	protected static final int iProjectItems = 2;
	protected static final int iRequirements = 3 ;
	protected static final int iViews = 4;
	protected static final int iReqDocuments = 5;
	protected static final int iDocuments = 6;
	protected static final int iRequirementTypes = 7;
	protected static final int iDocumentTypes = 8;
	protected static final int iGroups = 9;
	protected static final int iUsers = 10;
	protected static final int iPackages = 11;
	protected static final int iProjectStructure = 12;
	protected static final int iProjectSecurity = 13;
	protected static final int iProjectExplorer = 14;
	protected static int iLoadingFlag = -1;
	
	// ============= Flags for processing different project items ============
	
	
	private String sSelectedItem1 = "";
	private String sSelectedItem2 = "";	
	
	private  String sODA_URL = "";
	private  String sSelectedElementName = "";
	
	//public final static String sCurrDir = System.getProperty("user.dir");
	private static  int iFlag_Initialize = -1;
	private  int iFlagItemType = -1;
	
	//Authentication information
	private  String sUserName = "";
	private  String sPassword = "";
	private  String sProjectName = "";
	private String sServerInfo = "";
	
	
	//=====================  Flags and Variables =============================
	
	
	// ==================== URLs and Filter strings ========================
	
	// ===================== REST Services ==============================
	// Help URL
	
	private final static String sBaseHelpURL = "http://<Server Info>/ReqWebHelp/index.jsp?" +
									"topic=/com.ibm.reqpro.reqweb.help/reporting/t_reporting_client_datasource.html";
	
	// Using REST Services for Views 
	
	private final String sBaseRESTViewURL = "http://<Server Info>/ReqWeb/" +
										"Servlet/project/<Project Name>" +
										"/requirement?view=<enter ID>&traces=false&history=false";
			
	
	// Package URL
	private final String sBaseRESTPkgURL =  "http://<Server Info>/ReqWeb/" +
									"Servlet/project/<Project Name>" +
									"/package?query=<Package IDs>&includeviews=false&includedocs=false" +
									"&includereqs=false&traces=true&history=false";
	
	
	// REST Services to get list of projects
	private final String sBaseRESTBaseURL = "http://<Server Info>/ReqWeb/Servlet/project";
	
	// REST Service Project Explorer
	private final String sBaseProjectExplorer = "http://<Server Info>/ReqWeb/Servlet/" +
										"project/<Project Name>?" +
										"fulldetails=true&history=false";
	
	// REST services for project structure 
	
	private final String sBaseProjectStructure = "http://<Server Info>/ReqWeb/Servlet/" +
									    "project/<Project Name>?projectstructure=true";

	// REST Services for project security
	private final String sBaseProjectSecurity = "http://<Server Info>/ReqWeb/Servlet/project/" +
										"<Project Name>?projectsecurity=true";
	
	
	// REST Service for authentication
	
	private final String sBaseAuthenticationURL = "http://<Server Info>/ReqWeb/Servlet/project" +
											"/<Project Name>" ;
	
	// REST Services for package Explorer
	
	private final String sBasePackageExplorer = "http://<Server Info>/ReqWeb/Servlet/project/" +
										"<Project Name>/package?explorer=true&" +
										"includeattrmtrxviews=false&includedocs=false";
	
	// REST Service for Documents Information
	
	private final String sBaseDocumentURL = "http://<Server Info>/ReqWeb/Servlet/project/" +
												"<Project Name>/document?" +
												"keys=<Enter ID>&includehistory=false&includetraces=false";
	
	// Variables to store REST URLs during execution with project and server information
	private String sRESTViewURL = "";
	private String sRESTPkgURL = "";
	private String sRESTBaseURL = "";
	private String sProjectExplorerURL = "";
	private String sProjectStructureURL = "";
	private String sProjectSecurityURL = "";
	private String sPackageExplorerURL = "";
	private String sAuthenticationURL = "";
	private String sDocumentURL = "";
	
	// ===================== REST Services ==============================
		
	
	
	// =========== Vega Data Services specific implementations ===============
	
//	// Users Filter	
//	private String sUsersDefaultFilter = "?fields=*/*/*/*";  //  @jve:decl-index=0:
//	private String sUsersGroupFilter = "?fields=*/*/*/*/*";  //  @jve:decl-index=0:
//	
//	// Groups Filter
//	private String sGroupsDefaultFilter = "?fields=*/*/*/*";
//	private String sGroupsPermFilter = "?fields=*/*/*/*/*/*";  
//
//	// Document Types Filter
//	private String sDocTypesFilter = "?fields=*/*/*/*/*";
//	
//	// Requirement Types
//	private String sReqTypesFilter = "?fields=*/*/*/*";
	
//	// Server Base URL 
//	private String sBaseURL = "http://<Server Info>/VegaDataServices/requisitepro?fields=*/*/*/*";
//	
//	
//	
//	
//	// Documents Filter
//	private final String sDocRevFilter = "?fields=*/*/*/(FullPath|FileDateTime|FileName|Extension|Name|Description|DocumentID|ParentPackage/*|DocumentType/*/*|Revisions/*/*/*)";
//	private final String sDocReqFilter = "?fields=*/*/*/(FullPath|FileDateTime|FileName|Extension|Name|Description|DocumentID|ParentPackage/*|DocumentType/*/*|Requirements/*/*/*)";
//	 
//	
//	// Package Filter
//	// Using REST Services for Packages
//	
//	private final String sNoOptionFilter = "?fields=*/*/*/(Name|Description|UniqueID|GUID|ParentPackage/*|Project/*)";
//	private final String sOptionFilter = "?fields=*/*/*/(Name|Description|UniqueID|GUID|ParentPackage/*|Project/*";
//	private final String sViewOption = "|Views/*/*";
//	private final String sDocOption = "|Documents/*/*/*/*";
//	private final String sReqOption = "|Requirements/*/*";
//	private final String sOptionclose = ")";
//	
	
	// =========== Vega Data Services specific implementations ===============
	
	
	//===================== GUI Components =============================
			
	private Label projectNameLabel = null;
	public static Combo projectListCombo = null;
	//private ComboViewer comboViewer = null;
	private static Text userNameText = null;
	private static Text passwordText = null;
	//private Label label1 = null;
	//private Label label2 = null;
	private static Button projectButton = null;
	public static Combo projectItemCombo = null;
	private Label userNameLabel = null;
	private Label passwordLabel = null;
	private Label projectItemsLabel = null;
	private static Button projectItemButton = null;
	public static Tree tree = null;	
	private static Button generateURLButton = null;
	public static Button checkBox = null;
	public static Button checkBox1 = null;
	public static Button checkBox2 = null;
	public static Button checkBox3 = null;
	private static Button checkAllItems = null;
	private static TreeItem[] selectedNode = null;
	private static String sSelectedNodeIDs = "";
	protected static String sIDList = ""; 

	//===================== GUI Components =============================
	
	// ======================= GUI Initializations ====================
	public RESTDataSource(Composite parent, int style) {
		super(parent, SWT.NONE);
		//initialize();
	}

	public void initialize() {
		GridData gridData = new GridData();
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 1;
		projectNameLabel = new Label(this, SWT.NONE);
		projectNameLabel.setText(ReqProDriverResourceBundle.getString("PROJECT"));
		projectNameLabel.setBounds(new Rectangle(16, 172, 76, 14));
		//label.setBounds(new Rectangle(15, 15, 61, 16));
		projectNameLabel.setLayoutData(gridData);
		
		this.setLayout(null);
		createCombo();
		this.setSize(new Point(531, 757));
		
		userNameText = new Text(this, SWT.BORDER);
		userNameText.setBounds(new Rectangle(106, 202, 151, 16));
		
		passwordText = new Text(this, SWT.PASSWORD | SWT.BORDER);
		passwordText.setBounds(new Rectangle(106, 232, 151, 16));
		
		
		projectButton = new Button(this, SWT.NONE);
		projectButton.setBounds(new Rectangle(376, 172, 121, 16));
		projectButton.setText(ReqProDriverResourceBundle.getString("OK"));
		
		// ======================   Listener ================================
		projectButton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("widgetSelected()");
				
				projectLoginErrLabel.setVisible(false);
				projectLoginErrLabel.setText("");
				
				sUserName = userNameText.getText();
				sPassword = passwordText.getText();
				sProjectName = projectListCombo.getText().replaceAll(" ", "%20");
				
				// Enter the project name in the REST Services URL
				enterProjectInforamtion(); 
				
				projectItemButton.setEnabled(false);
				projectItemCombo.removeAll();
				projectItemCombo.setEnabled(false);
				projectItemCombo.setText(ReqProDriverResourceBundle.getString("PLEASESELECTPROJECTITEM"));
				tree.removeAll();
				tree.setEnabled(false);
				
				try
				{
					// Login to the project with provided details
					
					String temp = "";
					
					String sProjectName = sSelectedItem1;
					//String sURL = "";
					sProjectName = sProjectName.replaceAll(" ", "%20");
					projectLoginErrLabel.setVisible(true);
					projectLoginErrLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
					projectLoginErrLabel.setText(ReqProDriverResourceBundle.getString("AUTHENTICATING")+"....");
					
					
					// Append Authentication information
					
					sAuthenticationURL = sAuthenticationURL + "?user=" + sUserName + "&password="+ sPassword;
							
					
					//System.out.println("AuthenticationURL : - "+ sAuthenticationURL);
					
					//sURL = "http://localhost:8080/VegaDataServices/requisitepro/<Project Name>?username=admin&password=admin&fields=*/*/*/*/*/*/*";
					
					////System.out.println("URL : - "+ sURL);
					URL u = new URL(sAuthenticationURL);
					InputStream is = u.openStream();
					RESTDataSource.iFlag_Process = RESTDataSource.iProjectItems;
					RDS_xmlparser.parse(is);
					
					// Enable the next set of controls
					if(projectItemButton.getEnabled() == false)
						projectItemButton.setEnabled(true);
					
					projectItemCombo.setEnabled(true);
					projectItemCombo.setText(ReqProDriverResourceBundle.getString("PLEASESELECTPROJECTITEM"));
					
					projectLoginErrLabel.setVisible(true);
					projectLoginErrLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
					projectLoginErrLabel.setText(ReqProDriverResourceBundle.getString("AUTHENTICATIONSUCCESS"));
					
					
				}
				catch(Exception e1)
				{
					projectLoginErrLabel.setVisible(true);
					projectLoginErrLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_RED));
					projectLoginErrLabel.setText(ReqProDriverResourceBundle.getString("LOGINERROR"));
					
					//DIsable Apropriate controls
					projectItemButton.setEnabled(false);
					projectItemCombo.setEnabled(false);
					
					// Display the Error Message
					MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
//					mProjectError.setMessage("Cannot Login into the Project.  Please check the Authentication" +
//							"Information ");
					
					mProjectError.setMessage(ReqProDriverResourceBundle
							.getString("PROJECTLOGINERROR"));
					mProjectError.open();
					
					
					e1.printStackTrace();
				}


				
			}
		});
		
		createCombo1();
		
		userNameLabel = new Label(this, SWT.NONE);
		userNameLabel.setBounds(new Rectangle(16, 202, 76, 16));
		userNameLabel.setText(ReqProDriverResourceBundle.getString("USERNAME"));
		
		passwordLabel = new Label(this, SWT.NONE);
		passwordLabel.setBounds(new Rectangle(16, 232, 76, 16));
		passwordLabel.setText(ReqProDriverResourceBundle.getString("PASSWORD"));
		
		
		projectItemsLabel = new Label(this, SWT.NONE);
		projectItemsLabel.setBounds(new Rectangle(16, 314, 76, 16));
		projectItemsLabel.setText(ReqProDriverResourceBundle.getString("PROJECTITEMS"));
		
		projectItemButton = new Button(this, SWT.NONE);
		projectItemButton.setBounds(new Rectangle(376, 314, 121, 16));
		projectItemButton.setText(ReqProDriverResourceBundle.getString("OK"));
		
		if(projectItemButton.getEnabled() == false)
		{
			//System.out.println("Button 1 is disabled");
		}
		
		
		// ======================   Listener ================================
		
		projectItemButton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("widgetSelected()"); 
				if (!(projectItemCombo.getText().equalsIgnoreCase(ReqProDriverResourceBundle.getString("PLEASESELECTPROJECTITEM"))) )
				{
					tree.setEnabled(true);
					
					// Clear the List of IDs.
					sIDList = "";
				
					try
					{
						tree.removeAll();
						String sURL = (String) RESTDataSource.projectItemCombo.getData(sSelectedItem2);
						//sURL = "Needs to be refactored. Woud be removed after that ";
						String sSelectedProjectItem = sSelectedItem2;
						
						//======== Creating Report on Project Information =============
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("PROJECT")))
						{
							iFlagItemType = RESTDataSource.iProjectExplorer;
							TreeItem treeNode = new TreeItem(RESTDataSource.tree, 0);
							treeNode.setText(ReqProDriverResourceBundle.getString("GENERATEURLFORPROJECTINFORMATION"));
							//node_Parent = treeNode;
							treeNode.setImage(ReqProUIActivator.getImage("icons/proj_adm.gif"));
							treeNode.setData("Type", "Project Structure");
							
							generateURLButton.setEnabled(true);
							checkAllItems.setEnabled(false);
							checkAllItems.setSelection(false);
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONALLITEMS"));
							
							disablefilter();
							checkBox.setVisible(true);
							checkBox.setEnabled(true);
							checkBox.setText(ReqProDriverResourceBundle.getString("HISTORY"));
							
						}
						
						//=================== Creating Report on Requirements ==================================
						//if(sURL.substring(sURL.lastIndexOf("/")+1).equalsIgnoreCase("Requirements"))
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("REQUIREMENTS")))
						{
							iFlagItemType = RESTDataSource.iRequirements;
							
							
							sURL = sPackageExplorerURL;
							//Append User inforamtion
							sURL =  sURL + "&user="+sUserName + "&password="+sPassword;
							
							// Enable filter for Getting Views
							sURL = sURL.replaceFirst("includeattrmtrxviews=false", "includeattrmtrxviews=true");
							
							sURL = sURL.replaceAll(" ", "%20");
							
							//System.out.println("Package Explorer URL : - "+ sURL);
							
							tree.setEnabled(true);
							tree.removeAll();
							
							iLoadingFlag = 1;
							TreeItem temp = new TreeItem(tree,0);
							temp.setText(ReqProDriverResourceBundle.getString("PLEASEWAIT"));
							temp.setImage(ReqProUIActivator.getImage("icons/loading16.gif"));
							
							
							URL u = new URL(sURL);
							InputStream is = u.openStream();
							RESTDataSource.iFlag_Process = RESTDataSource.iRequirements;
							
							RDS_xmlparser.parse(is);
							generateURLButton.setEnabled(true);
						
							checkAllItems.setEnabled(true);
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONALLITEMS"));
							checkAllItems.setSelection(false);
							// =================== Enable Filters specific to Report Items ================
					        
							//checkBox4.setText("Report on all Documents");
							disablefilter();				
						
				        	
				        	checkBox.setVisible(true);
				        	checkBox.setEnabled(true);
				        	checkBox.setText(ReqProDriverResourceBundle.getString("TRACEABILITY"));
				        	
				        	checkBox1.setVisible(true);
				        	checkBox1.setEnabled(true);
				        	checkBox1.setText(ReqProDriverResourceBundle.getString("HISTORY"));
				        	
				        	
						}
						
						//===================== Creating Report on Documents ==================================
						
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("DOCUMENTS")))
						{
							iFlagItemType = RESTDataSource.iReqDocuments;
							
						
							sURL = sPackageExplorerURL;
							//Append User information
							sURL =  sURL + "&user="+sUserName + "&password="+sPassword;
							
							// Enable filter for Getting Views
							sURL = sURL.replaceFirst("includedocs=false", "includedocs=true");
							
							
							sURL = sURL.replaceAll(" ", "%20");
							
						
							////System.out.println("URL : - "+ sURL);
							
							tree.setEnabled(true);
							tree.removeAll();
							iLoadingFlag = 1;
							TreeItem temp = new TreeItem(tree,0);
							temp.setText(ReqProDriverResourceBundle.getString("PLEASEWAIT"));
							temp.setImage(ReqProUIActivator.getImage("icons/loading16.gif"));
							
							URL u = new URL(sURL);
							InputStream is = u.openStream();
							RESTDataSource.iFlag_Process = RESTDataSource.iReqDocuments;
							RDS_xmlparser.parse(is);
							generateURLButton.setEnabled(true);
							checkAllItems.setEnabled(true);
							checkAllItems.setSelection(false);
							// =================== Enable Filters specific to Report Items ================
					        
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONALLDOCUMENTS"));
							
							// disable buttons that are not required
							disablefilter();
							
							checkBox.setVisible(true);
				        	checkBox.setEnabled(true);
				        	checkBox.setText(ReqProDriverResourceBundle.getString("TRACEABILITY"));
				        	
				        	checkBox1.setVisible(true);
				        	checkBox1.setEnabled(true);
				        	checkBox1.setText(ReqProDriverResourceBundle.getString("HISTORY"));
				        	
	//			         	
					        
						}
						
						// ============================== Creating Report on Project Structure ===============
						
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("PROJECTSTRUCTURE")))
						{
							iFlagItemType = RESTDataSource.iProjectStructure;
	//						
							
							////System.out.println("URL : - "+ sURL);
	//						
							TreeItem treeNode = new TreeItem(RESTDataSource.tree, 0);
							treeNode.setText(ReqProDriverResourceBundle.getString("GENERATEURLFORPROJECTSTRUCTURE"));
							//node_Parent = treeNode;
							treeNode.setImage(ReqProUIActivator.getImage("icons/reqpro.gif"));
							treeNode.setData("Type", "Project Structure");
							
							TreeItem temp = new TreeItem(treeNode, 0);
							temp.setText(ReqProDriverResourceBundle.getString("REQUIREMENTTYPES"));
							//node_Parent = treeNode;
							temp.setImage(ReqProUIActivator.getImage("icons/rwReqType.gif"));
							temp.setData("Type", "Project Structure");
							
							temp = new TreeItem(treeNode, 0);
							temp.setText(ReqProDriverResourceBundle.getString("DOCUMENTTYPES"));
							//node_Parent = treeNode;
							temp.setImage(ReqProUIActivator.getImage("icons/rwDocType.gif"));
							temp.setData("Type", "Project Structure");
							
							temp = new TreeItem(treeNode, 0);
							temp.setText(ReqProDriverResourceBundle.getString("ATTRIBUTES"));
							//node_Parent = treeNode;
							temp.setImage(ReqProUIActivator.getImage("icons/rwAttr.gif"));
							temp.setData("Type", "Project Structure");
							
							treeNode.setExpanded(true);
							
							generateURLButton.setEnabled(true);
							checkAllItems.setEnabled(false);
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONALLITEMS"));
							checkAllItems.setSelection(false);
							
							disablefilter();
							checkBox.setVisible(true);
							checkBox.setEnabled(false);
							checkBox.setText(ReqProDriverResourceBundle.getString("NOOPTIONS"));
						}
						
						// ============================== Creating Report on Project Security ===============
						
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("PROJECTSECURITY")))
						{
							iFlagItemType = RESTDataSource.iProjectSecurity;
							//					
							TreeItem treeNode = new TreeItem(RESTDataSource.tree, 0);
							treeNode.setText(ReqProDriverResourceBundle.getString("GENERATEURLFORPROJECTSECURITY"));
							//node_Parent = treeNode;
							treeNode.setImage(ReqProUIActivator.getImage("icons/reqpro.gif"));
							treeNode.setData("Type", "Project Security");
							
							TreeItem temp = new TreeItem(treeNode, 0);
							temp.setText(ReqProDriverResourceBundle.getString("USERGROUPS"));
							//node_Parent = treeNode;
							temp.setImage(ReqProUIActivator.getImage("icons/group.gif"));
							temp.setData("Type", "Project Security");
							
							temp = new TreeItem(treeNode, 0);
							temp.setText(ReqProDriverResourceBundle.getString("USERS"));
							//node_Parent = treeNode;
							temp.setImage(ReqProUIActivator.getImage("icons/user.gif"));
							temp.setData("Type", "Project Security");
							
							treeNode.setExpanded(true);
							
							generateURLButton.setEnabled(true);
							checkAllItems.setEnabled(false);
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONALLITEMS"));
							checkAllItems.setSelection(false);
							
							disablefilter();
							checkBox.setVisible(true);
							checkBox.setText(ReqProDriverResourceBundle.getString("NOOPTIONS"));
						}
						
						
						
						// ================= Create Report on Packages =============================
						if(sSelectedProjectItem.equalsIgnoreCase(ReqProDriverResourceBundle.getString("PACKAGES")))
						{
							iFlagItemType = RESTDataSource.iPackages;
							
							sURL = sPackageExplorerURL;
							//Append User information
							sURL =  sURL + "&user="+sUserName + "&password="+sPassword;
							
							
							sURL = sURL.replaceAll(" ", "%20");
							
							//System.out.println("URL : - "+ sURL);
							
							tree.setEnabled(true);
							tree.removeAll();
							iLoadingFlag = 1;
							TreeItem temp = new TreeItem(tree,0);
							temp.setText(ReqProDriverResourceBundle.getString("PLEASEWAIT"));
							temp.setImage(ReqProUIActivator.getImage("icons/loading16.gif"));
							
							
							URL u = new URL(sURL);
							InputStream is = u.openStream();
							RESTDataSource.iFlag_Process = RESTDataSource.iPackages;
							RDS_xmlparser.parse(is);
							generateURLButton.setEnabled(true);
							checkAllItems.setEnabled(true);
							checkAllItems.setSelection(false);
							checkAllItems.setText(ReqProDriverResourceBundle.getString("REPORTONCHILDPACKAGES"));
							
							disablefilter();
							checkBox.setVisible(true);
							checkBox.setEnabled(true);
							checkBox.setText(ReqProDriverResourceBundle.getString("REQUIREMENTS"));
							
							checkBox1.setVisible(true);
							checkBox1.setEnabled(true);
							checkBox1.setText(ReqProDriverResourceBundle.getString("DOCUMENTS"));
							
							checkBox2.setVisible(true);
							checkBox2.setEnabled(true);
							checkBox2.setText(ReqProDriverResourceBundle.getString("VIEWS"));
							
							checkBox3.setVisible(true);
							checkBox3.setEnabled(true);
							checkBox3.setText(ReqProDriverResourceBundle.getString("HISTORY"));
						}
					}
					catch(Exception e1)
					{
						// Display the Error Message
						MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
					
						mProjectError.setMessage(ReqProDriverResourceBundle
								.getString("SERVERDATAERROR"));
						mProjectError.open();
						e1.printStackTrace();
					}
	
				}
				else
				{
					// Display the Error Message
					MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
				
					mProjectError.setMessage(ReqProDriverResourceBundle
							.getString("PROJECTITEMSELECTERROR"));
					mProjectError.open();
					
				}
		}

			private void disablefilter() {
				checkBox.setVisible(false);
				checkBox1.setVisible(false);
				checkBox2.setVisible(false);
				checkBox3.setVisible(false);
				
				checkBox.setEnabled(false);
				checkBox1.setEnabled(false);
				checkBox2.setEnabled(false);
				checkBox3.setEnabled(false);
				
				checkBox.setSelection(false);
				checkBox1.setSelection(false);
				checkBox2.setSelection(false);
				checkBox3.setSelection(false);
				
				
			}
		});
		
		
		
		//======================== Creating Tree to explore for Report Preparation ==================
		tree = new Tree(this, SWT.V_SCROLL |SWT.H_SCROLL | SWT.BORDER | SWT.MULTI);
		tree.setBounds(new Rectangle(15, 390, 466, 211));
		
		tree.setToolTipText(ReqProDriverResourceBundle.getString("PLEASESELECTPROJECTITEM"));
		
		// ======================   Listener ================================  	 
		
		tree.addListener(SWT.Selection, new Listener(){

			public void handleEvent(Event arg0) {
				
				//sODA_URL = (String) ((TreeItem)(arg0.item)).getData(("URL"));
				
				// save the selected node
				
				//selectedNode = ((TreeItem)(arg0.item));
				generateURLButton.setEnabled(true);
				
				
			}
  		  
  	  });
  	  
		
		// ======================   Listener ================================
		tree.addListener(SWT.Expand, new Listener(){

			public void handleEvent(Event e) {
				
				//((TreeItem)e.item).setImage(ReqProUIActivator.getImage("icons/folder_o.gif"));
//				ImageDescriptor imgDescriptor = ReqProUIActivator.getImageDescriptor("icons/folder_o.gif");
//				Image img =  imgDescriptor.createImage();
				((TreeItem)e.item).setImage(ReqProUIActivator.getImage("icons/folder_o.gif"));
			}
  		  
  	  });
  	   
		tree.addListener(SWT.Collapse, new Listener(){

			public void handleEvent(Event e) {
				if(iFlagItemType == RESTDataSource.iReqDocuments)
				{
					((TreeItem)e.item).setImage(ReqProUIActivator.getImage("icons/doc_folder.gif"));
				}
				else
				{
					((TreeItem)e.item).setImage(ReqProUIActivator.getImage("icons/folder_c.gif"));
				}
				
			}
		  
	  });
		
		//============================= Tree End ================================================
		
		generateURLButton = new Button(this, SWT.NONE);
		generateURLButton.setBounds(new Rectangle(252, 613, 230, 22));
		generateURLButton.setText(ReqProDriverResourceBundle.getString("GENERATEURL"));
		
		generateURLButton.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("widgetSelected()"); 
				//group2.setEnabled(true);
				String sReportItemType = "";
				sSelectedNodeIDs = "";
				
				
				// Get the List of IDs of all selected node in the tree
				selectedNode = tree.getSelection();
				// Store the IDs of all selected node
				
				String string = "";
				for (int i = 0; i < selectedNode.length; i++)
				{ 
					string = (String) selectedNode[i].getData("ID");
					System.out.println("Selection={" + string + "}");
					
					if(string != null)
					{
						sSelectedNodeIDs = sSelectedNodeIDs + "," + string;				
					}
			        
			      }
				
				sSelectedNodeIDs = sSelectedNodeIDs.replaceFirst(",","");
				System.out.println("Selected Nodes ={" + sSelectedNodeIDs + "}");
				
				
				
				if(iFlagItemType == RESTDataSource.iRequirements)
				{	
					
					try {
						sReportItemType = "View";//(String) selectedNode.getData("Type");
					
					
						if(sReportItemType.equalsIgnoreCase("View"))
						{
							// Get the view id to be sent to REST Services
						
							
							//String sViewID = (String) selectedNode.getData("ID");
							//System.out.println("Selected View ID : " + sViewID);
							
							// Generating URL for the selected View
							
							//sODA_URL = sRESTViewURL.replaceAll("<enter ID>", sViewID);
							
							// Set the URL for requirements
							sODA_URL = sRESTViewURL; 
							
							if(checkBox.getSelection() == true)
							{
								sODA_URL = sODA_URL.replaceAll("traces=false","traces=true");
							}
							
							if(checkBox1.getSelection() == true)
							{
								sODA_URL = sODA_URL.replaceAll("history=false","history=true");
							}
						
							if(checkAllItems.getSelection() == true)
							{
								// modify the URL to report on all items
								// If the ID list startes with " , " then replace that with blank
								if(sIDList.startsWith(","))
								{
									sIDList = sIDList.replaceFirst(",", "");
								}
								sODA_URL = sODA_URL.replaceFirst("<enter ID>", sIDList);
								
							}
							else
							{
								sODA_URL = sODA_URL.replaceFirst("<enter ID>", sSelectedNodeIDs);
							}
							
							MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
							mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORREQ"));
							mGeneratedUrl.open();
						}
						else
						{
							//generateURLButton.setText("URL Generated for the View - "+ sSelectedElementName);
							MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
							mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("PLEASESELECTVIEW"));
							mGeneratedUrl.open();
						}
						
					} catch (Exception e1) {
						
						MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
						mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("PLEASESELECTVIEW"));
						mGeneratedUrl.open();
					}
				}

				else if(iFlagItemType == RESTDataSource.iReqDocuments)
				{
					sReportItemType = "Document";//(String) selectedNode.getData("Type");
					if(sReportItemType.equalsIgnoreCase("Document"))
					{
						sODA_URL = sDocumentURL; 
						
						//======== Build the URL based on Filter options ================
						if(checkBox.getSelection() == true)
						{
							sODA_URL = sODA_URL.replaceFirst("includehistory=false", "includehistory=true");
						}
						if(checkBox1.getSelection() == true)
						{
							sODA_URL = sODA_URL.replaceFirst("includetraces=false", "includetraces=true");
						}
					
						
						if(checkAllItems.getSelection() == true)
						{
							// modify the URL to report on all items
							// If the ID list startes with " , " then replace that with blank
							if(sIDList.startsWith(","))
							{
								sIDList = sIDList.replaceFirst(",", "");
							}
							sODA_URL = sODA_URL.replaceFirst("<Enter ID>", sIDList);
							
						}
						else
						{
							sODA_URL = sODA_URL.replaceFirst("<Enter ID>", sSelectedNodeIDs);
						}
						
						//generateURLButton.setText("URL Generated for the Doc - "+ sSelectedElementName);
						
						MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
						mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORDOC"));
						mGeneratedUrl.open();
					}
					else
					{
						//generateURLButton.setText("URL Generated for the View - "+ sSelectedElementName);
						MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
						mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("PLEASESELECTDOC"));
						mGeneratedUrl.open();
					}
				
				
				}
				
				else if(iFlagItemType == RESTDataSource.iProjectStructure)
				{
					//generateURLButton.setText("URL Generated for the ReqType - "+ sSelectedElementName);
					
					MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
					mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORSTRUCTURE"));
					mGeneratedUrl.open();
					
					sODA_URL = sProjectStructureURL;
				
				}
				else if(iFlagItemType == RESTDataSource.iProjectSecurity)
				{
					//generateURLButton.setText("URL Generated for the ReqType - "+ sSelectedElementName);
					
					MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
					mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORSECURITY"));
					mGeneratedUrl.open();
					
					sODA_URL = sProjectSecurityURL;

				}

				else if(iFlagItemType == RESTDataSource.iProjectExplorer)
				{
					//generateURLButton.setText("URL Generated for the ReqType - "+ sSelectedElementName);
					
					MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
					mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORPROJECT"));
					mGeneratedUrl.open();
					
					sODA_URL = sProjectExplorerURL;
					if(checkBox.getSelection() == true)
					{
						// modify the URL to report on all items
						sODA_URL = sODA_URL.replaceFirst("history=false", "history=true");
						
					}
				}
								
				else if(iFlagItemType == RESTDataSource.iPackages)
				{
					// Update ODA URL with the REST Services URL
					
						try {
							sReportItemType = "Package";//(String) selectedNode.getData("Type");
							if (sReportItemType.equalsIgnoreCase("Package")) {
								sODA_URL = sRESTPkgURL;
							
								if (checkBox.getSelection() == true) {

									// Enable Requirements options
									sODA_URL = sODA_URL.replaceFirst(
											"includereqs=false", "includereqs=true");

								}
								if (checkBox1.getSelection() == true) {
									// Enable Requirements options
									sODA_URL = sODA_URL.replaceFirst(
											"includedocs=false", "includedocs=true");

								}
								if (checkBox2.getSelection() == true) {
									// Enable Requirements options
									sODA_URL = sODA_URL.replaceFirst(
											"includeviews=false", "includeviews=true");

								}
								if (checkBox3.getSelection() == true) {
									// Enable Requirements options
									sODA_URL = sODA_URL.replaceFirst("history=false",
											"history=true");

								}
								// If report on child packages is enabled, get the list of IDs
								String sIDList = "";
								iDsList.clear();
								if (checkAllItems.getSelection() == true) {

									// Traverse through all selected node and then child packages of all selected node
									selectedNode = tree.getSelection();
									// Store the IDs of all selected node
									
									for (int i = 0; i < selectedNode.length; i++)
									{
										TreeItem tempNode = selectedNode[i];
									
										if (tempNode != null) {
											getSubPkgsId(tempNode);
										
										}
									}
									
									Iterator itr = iDsList.iterator();
									while (itr.hasNext()) {
										sIDList =  sIDList + "," + (String) itr.next();
									}

									sIDList = sIDList.replaceFirst(",", "");
									
									sODA_URL = sODA_URL.replaceFirst("<Package IDs>",
											sIDList);
								} else {
									
									selectedNode = tree.getSelection();
									// Store the IDs of all selected node
									
									for (int i = 0; i < selectedNode.length; i++)
									{
										TreeItem tempNode = selectedNode[i];
									
										if (tempNode != null) {
											sIDList = sIDList + ","+(String) tempNode.getData("ID");
										
										}
									}
									
									sIDList = sIDList.replaceFirst(",", "");
									sODA_URL = sODA_URL.replaceFirst("<Package IDs>",
											sIDList);
								}
								//generateURLButton.setText("URL Generated for the Package - "+ sSelectedElementName);
								MessageBox mGeneratedUrl = new MessageBox(Display
										.getCurrent().getActiveShell(),
										SWT.ICON_INFORMATION);
								mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORPKG"));
								mGeneratedUrl.open();
							}
							else
							{
								//generateURLButton.setText("URL Generated for the Package - "+ sSelectedElementName);
								
								MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
								mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("PLEASESELECTPKG"));
								mGeneratedUrl.open();
							}
						} catch (Exception e1) {

							MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
							mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("PLEASESELECTPKG"));
							mGeneratedUrl.open();
						}
						
				}
				else if(iFlagItemType == RESTDataSource.iProjectExplorer)
				{
					//generateURLButton.setText("URL Generated for the ReqType - "+ sSelectedElementName);
					
					MessageBox mGeneratedUrl = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
					mGeneratedUrl.setMessage(ReqProDriverResourceBundle.getString("URLGENERATEDFORPROJECT"));
					
					sODA_URL = sProjectExplorerURL;
				}
				generateURLButton.setEnabled(true);
				
				// Un-comment this line to get it working in the ODA Driver 
				// Set the Flag if the URL is REST URL
				
				//XMLSelectionPageHelperModifed.setParameters(sODA_URL);
				ReqProGuiHelper.setGeneratedURL(sODA_URL);
				System.out.println(sODA_URL);
				//ReqProGuiHelper.setGeneratedURL(sODA_URL);
				
				// Caching the user info for Data Access
				ReqProUIActivator.mUserInfo.put(sProjectName, sUserName+":$urya:"+sPassword);
				
				//Cache that into runtime driver also
				com.ibm.rational.report.oda.reqpro.runtime.ReqProODARuntimePlugin.
				mUserInfo.put(sProjectName, sUserName+":$urya:"+sPassword);
				
				//Enable the appropriate flag - Which service is being used to fetch data
//				ReqProUIActivator.mUserInfo.put("ReportItem Flag", "REST");
//				ReqProUIActivator.mUserInfo.put("Flag", "RDS");
//				
//				//System.out.println("\n==============$$$$$$$$=================\nThe URL sent to Birt : "+sODA_URL);
//				//System.out.println("Cached User Info : \n Project name"+sProjectName+"\n usename"
//						+ sUserName + "\npassword "+ sPassword);
				
			// clear the data
				sODA_URL = "";
			}
		});
		
		checkBox = new Button(this, SWT.CHECK);
		checkBox.setBounds(new Rectangle(30, 690, 196, 17));
		//checkBox.setText("Option 1");
		checkBox1 = new Button(this, SWT.CHECK);
		checkBox1.setBounds(new Rectangle(255, 690, 241, 16));
		//checkBox1.setText("Option 2");
		checkBox2 = new Button(this, SWT.CHECK);
		checkBox2.setBounds(new Rectangle(30, 720, 211, 16));
		//checkBox2.setText("Option 3");
		checkBox3 = new Button(this, SWT.CHECK);
		checkBox3.setBounds(new Rectangle(255, 720, 241, 16));
		//checkBox3.setText("Option 4");
		
		//===================== Filters =========================
		checkAllItems = new Button(this, SWT.CHECK);
		checkAllItems.setBounds(new Rectangle(30, 614, 200, 16));
		//checkAllItems.setText("Report on all Items");
		
		//=================== Server GUI Components ============
		serverInfoLabel = new Label(this, SWT.NONE);
		serverInfoLabel.setBounds(new Rectangle(18, 32, 102, 13));
		serverInfoLabel.setText(ReqProDriverResourceBundle.getString("SERVERNAME"));
		serverText = new Text(this, SWT.BORDER);
		serverText.setBounds(new Rectangle(137, 31, 213, 16));
		serverText.setText(ReqProDriverResourceBundle.getString("PLEASEENTERSERVERADDRESS")+"....");
		pingButton = new Button(this, SWT.NONE);
		pingButton.setBounds(new Rectangle(376, 30, 119, 18));
		pingButton.setText(ReqProDriverResourceBundle.getString("CONNECT"));
		serverNameLabel = new Label(this, SWT.NONE);
		serverNameLabel.setBounds(new Rectangle(18, 59, 478, 17));
		serverNameLabel.setText("");
		serverDefaultChkBox = new Button(this, SWT.CHECK);
		serverDefaultChkBox.setBounds(new Rectangle(17, 89,400, 13));
		serverDefaultChkBox.setText(ReqProDriverResourceBundle.getString("DEFAULTSERVER"));
		helpButton = new Button(this, SWT.NONE);
		//helpButton.setBounds(new Rectangle(209, 90, 285, 19));
		//helpButton.setText("HELP");
		
		
		//=================== Server GUI Components ============
		
		
		//============ Adding listeners to Server GUI Components====
		pingButton.addListener(SWT.Selection, new Listener(){
			
			public void handleEvent(Event arg0) {
				projectListCombo.removeAll();
				projectListCombo.setText(ReqProDriverResourceBundle.getString("PROJECTSELECT"));
				pingButton.setText(ReqProDriverResourceBundle.getString("CONNECTING")+"....");
				String sHostName = "";
				sServerInfo = serverText.getText();
				serverNameLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
				serverNameLabel.setText(ReqProDriverResourceBundle.getString("CONNECTINGTOSERVER")+"....");
				
				// Disable  Project GUI Controls
				projectListCombo.setEnabled(false);
				userNameText.setEnabled(false);
				passwordText.setEnabled(false);
				projectButton.setEnabled(false);
				
				if((sHostName = pingServer(sServerInfo)) == null)
				{
					iFlag_Initialize = 1;
					disableConrols();
					
					serverNameLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_RED));
					serverNameLabel.setText(ReqProDriverResourceBundle.getString("SERVERPINGERROR"));
					
					
					serverDefaultChkBox.setEnabled(false);
					pingButton.setText(ReqProDriverResourceBundle.getString("CONNECT"));
					
					// Display the Error Message
					MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
					//mProjectError.setMessage("Pinging to the server Failed.  Please enter a valid address");
					
					mProjectError.setMessage(ReqProDriverResourceBundle.getString("SERVERPINGERROR"));
					mProjectError.open();
				}
				else
				{
					serverNameLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
					serverNameLabel.setText(ReqProDriverResourceBundle.getString("FINDRESTSERVICE")+"....");
					serverDefaultChkBox.setEnabled(true);
					
					
					// Update Base URL with the server info 
					String sURL = ""; //sBaseURL.replaceFirst("<Server Info>", serverText.getText());
					sURL = sBaseRESTBaseURL.replaceFirst("<Server Info>", serverText.getText());
					
					
					
					parseBaseURL(sURL);
					
					pingButton.setText(ReqProDriverResourceBundle.getString("CONNECT"));
					
					
					
					
					
					
				}
				
				
				
			}
			
		});
		
		
		helpButton.addListener(SWT.Selection, new Listener(){

			public void handleEvent(Event arg0) {
				
				
				try {
					String server = pingServer(serverText.getText());
//					 if(server.indexOf(":")!=-1)
//				    	 server = server.substring(0,server.indexOf(":"));
					
					// temp modification
					server = "http://localhost:8080/";
					// server = server + "/";
//					 
					String sHelp = "rundll32 url.dll,FileProtocolHandler " + server;
					Runtime.getRuntime().exec(sHelp);
				} catch (IOException e) {
					
					e.printStackTrace();
				}
				
			
			}
			    

			
		});
		
		
		serverDefaultChkBox.addSelectionListener(new SelectionListener(){

			public void widgetDefaultSelected(SelectionEvent e) {
				
				
			}

			public void widgetSelected(SelectionEvent e) {
				String serverInfo = serverText.getText();
				
				// save the info
				if(serverDefaultChkBox.getSelection() == true)
				{
					serverText.setEditable(false);
					ReqProUIActivator.mUserInfo.put("Server", serverInfo);
				}
				
				if(serverDefaultChkBox.getSelection() == false)
				{
					serverText.setEditable(true);
					
				}
			}
			
		});
		
		//============ Adding listeners to Server GUI Components====
		
		createGroup();
		createGroup1();
		createGroup2();
		createGroup3();
		createGroup4();
		
		
		
		// ========= Setting all controls as Disabled ==========
		iFlag_Initialize = 1;
		
		
		// chk whether we already have serve rinfo with us
		if(ReqProUIActivator.mUserInfo.get("Server") != null)
		{
				serverText.setText((String) ReqProUIActivator.mUserInfo.get("Server"));
				serverText.setEditable(false);
				serverDefaultChkBox.setSelection(true);
				
		}
//		
		
		
	}
	private static List iDsList = new ArrayList();
	private Label serverInfoLabel = null;
	private static Text serverText = null;
	private Button pingButton = null;
	private Label serverNameLabel = null;
	private Button serverDefaultChkBox = null;
	private Button helpButton = null;
	private Group group = null;
	private Group group1 = null;
	private Group group2 = null;
	private Group group3 = null;
	private Group group4 = null;
	// Create a web browser
	private static Label projectLoginErrLabel = null;
   
	
	private void parseBaseURL(String sURL)
	{
		// ===============  Parse the Base URL to get the List of Projects ===========================
		try {
			URL url = new URL(sURL);
			InputStream is = url.openStream();
						
			RESTDataSource.iFlag_Process = RESTDataSource.iProject;
			
			RDS_xmlparser.parse(is);
			serverNameLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
			serverNameLabel.setText(ReqProDriverResourceBundle.getString("CONNECTIONSUCCESS"));
			//Enable the Project GUI Controls
			projectListCombo.setEnabled(true);
			userNameText.setEnabled(true);
			passwordText.setEnabled(true);
			projectButton.setEnabled(true);
			
		} catch (Exception e1) {
			
			serverNameLabel.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_RED));
			serverNameLabel.setText(ReqProDriverResourceBundle.getString("RESTERROR"));			
			iFlag_Initialize = 1;
			disableConrols();
			// Display the Error Message
			MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
//			mProjectError.setMessage("Error - Not able to retrieve data from Vega Data Services" +
//					"   Please check the server information ");
//			
			mProjectError.setMessage(ReqProDriverResourceBundle.getString("RESTERROR"));
			mProjectError.open();
			
			
		} 
		
	}
	
	private void enterServerInfo()
	{
		
		// View URL
		sRESTViewURL = sBaseRESTViewURL.replaceFirst("<Server Info>", sServerInfo);
		
		// Package URL
		sRESTPkgURL = sBaseRESTPkgURL.replaceFirst("<Server Info>", sServerInfo);
		
		// Project Details URL
		sProjectExplorerURL = sBaseProjectExplorer.replaceFirst("<Server Info>", sServerInfo);
		
		// Project Structure URL
		sProjectStructureURL = sBaseProjectStructure.replaceFirst("<Server Info>", sServerInfo);
		
		// Project Security URL
		sProjectSecurityURL = sBaseProjectSecurity.replaceFirst("<Server Info>", sServerInfo);
		
		// Package Explorer URL
		sPackageExplorerURL = sBasePackageExplorer.replaceFirst("<Server Info>", sServerInfo);
		
		// Document URL 
		sDocumentURL = sBaseDocumentURL.replaceFirst("<Server Info>", sServerInfo);
		
		// Authentication URL
		sAuthenticationURL = sBaseAuthenticationURL.replaceFirst("<Server Info>", sServerInfo);
		
		
		
	}
	
	private void enterProjectInforamtion()
	{
		// Successful in connecting to the server and REST Services
		// Update the server information in all the URLs
		
		enterServerInfo();
		
		// View URL
		sRESTViewURL =  sRESTViewURL.replaceFirst("<Project Name>", sProjectName);
		
		// package URL
		sRESTPkgURL = sRESTPkgURL.replaceFirst("<Project Name>", sProjectName);
		
		// Project Details URL
		sProjectExplorerURL = sProjectExplorerURL.replaceFirst("<Project Name>", sProjectName);
		
		// Project Structure URL
		sProjectStructureURL = sProjectStructureURL.replaceFirst("<Project Name>", sProjectName);
		
		// Project Security URL
		sProjectSecurityURL = sProjectSecurityURL.replaceFirst("<Project Name>", sProjectName);
		
		// Package Explorer URL
		sPackageExplorerURL = sPackageExplorerURL.replaceFirst("<Project Name>", sProjectName);
		
		// Document URL 
		sDocumentURL = sDocumentURL.replaceFirst("<Project Name>", sProjectName);
		
		// Authentication URL
		sAuthenticationURL = sAuthenticationURL.replaceFirst("<Project Name>", sProjectName);
		
		
		
	}
	private void getSubPkgsId(TreeItem Node)
	{
				
		TreeItem [] nodeList = Node.getItems();
		if(Node.getData("ID") != null)
			if(!iDsList.contains((String)Node.getData("ID")))
			{
				iDsList.add((String)Node.getData("ID"));
			}
		//System.out.println("List adding Node Name : " + Node.getText());
		for(int i = 0 ; i < nodeList.length; i++ )
		{
			
			// Chk for sub packages
			//System.out.println("Node Name : " + Node.getText());
			getSubPkgsId(nodeList[i]);
		}
		
		
		return ;
	}
	public static void createFilters(Composite parent)
	{
		
	}
	
	private static String pingServer(String server)
	{
	   try
	   {
		   if(server.indexOf(":")!=-1)
		    	 server = server.substring(0,server.indexOf(":"));
		   
		   
		   InetAddress address = InetAddress.getByName(server);
		   String sHostName = address.getHostName();
	       //System.out.println("Name: " + sHostName);
	       //System.out.println("Addr: " + address.getHostAddress());
	      // //System.out.println("Reach: " + address.isReachable(3000));
	       
	       return sHostName;
	   }
	   catch (UnknownHostException e) {
	       return null;
	     }
	   
	   //Exception Handliing for isReachable()
//	   catch (IOException e)
//	   {
//		   //System.out.println("Error while pinging the server");
//		   return null;
//	   }
	  
	}
	public static void disableConrols()
	{
		if(iFlag_Initialize == 1)
		{
			// Disable GUI Items
			projectListCombo.setEnabled(false);
			userNameText.setEnabled(false);
			passwordText.setEnabled(false);
			projectButton.setEnabled(false);
			
			projectLoginErrLabel.setVisible(false);
			//projectLoginErrLabel.setText("Error : Cannot Login to the Project");
			
			
			
			tree.setEnabled(false);
			generateURLButton.setEnabled(false);
			projectItemCombo.setEnabled(false);
			projectItemButton.setEnabled(false);
			checkAllItems.setEnabled(false);
			
			checkBox.setEnabled(false);
			checkBox.setText(ReqProDriverResourceBundle.getString("OPTION")+"....");
			//checkBox.setEnabled(true);
			//checkBox.setText("< Please Select Report Item from Explorer to enable Filters >");
			checkBox1.setVisible(false);
			checkBox2.setVisible(false);
			checkBox3.setVisible(false);
			
			// Set default selection value
			checkAllItems.setSelection(false);
			checkBox.setSelection(false);
			checkBox1.setSelection(false);
			checkBox2.setSelection(false);
			checkBox3.setSelection(false);
			
			iFlag_Initialize = -1;
			
		}
	}
	
	// Perform Help 
	
	public static void performHelp()
	{
		
		if((serverText.getText() == null ||
				serverText.getText().equalsIgnoreCase(ReqProDriverResourceBundle.getString("PLEASEENTERSERVERADDRESS")+"....")))
		{
			
			// Display static help
			Shell shell = new Shell(Display.getCurrent().getActiveShell());
		    shell.setText(ReqProDriverResourceBundle.getString("REQPROHELP"));
		    shell.setLayout(new FillLayout());
		    shell.setSize(600,400);
			Browser browser;
			try {
				browser = new Browser(shell
						,SWT.NONE);
				// Navigate to Help
				
				// Use the Help.html file or use the help string
				
//				FileInputStream fis = new FileInputStream("Help/Help.html");
//				int x= fis.available();
//				byte b[]= new byte[x];
//				fis.read(b);
//				String content = new String(b);
//				
				String html = "<html><head></head><body><span style=\"color: rgb(0, 0, 205);\">" +
						"Enter the </span><span style=\"font-weight: bold; color: rgb(30, 144, 255);" +
						"\">Host Name</span><span style=\"color: rgb(0, 0, 205);\"> or <span style=" +
						"\"font-weight: bold; color: rgb(30, 144, 255);\">IP number</span> of the system " +
						"with the <span style=\"font-weight: bold; color: rgb(30, 144, 255);\">Reporting " +
						"Server</span>.</span><br style=\"color: rgb(0, 0, 205);\" /><span style=\"color: " +
						"rgb(0, 0, 205);\">By default the reporting server is the same as the Requisite Web " +
						"server.</span><br style=\"color: rgb(0, 0, 205);\" /><span style=\"font-weight: bold; " +
						"color: rgb(0, 0, 205);\"><br />Example:</span><span style=\"color: rgb(0, 0, 205);\"> " +
						"server3.mycompany.com or 256.17.122.101. After you enter the name of the server click " +
						"the Connect button to verify the server name and establish a connection.<br /><br />" +
						"<span style=\"font-weight: bold;\">Optional</span>: You can choose to use this " +
						"server as the default for future sessions.</span></body></html>";
				
				browser.setText(html);
			
				
				//String sfileURL = ReqProUIActivator.getFullFilePath("help/Help.html").toString();
				//browser.setFocus();
				browser.forceFocus();
				//browser.setBackgroundImage(ReqProUIActivator.getImage("icons/ReqPro-LogIn-background.JPG"));
				
				//browser.setUrl(html);
				//shell.setImage(ReqProUIActivator.getImage("icons/icons/ReqPro-LogIn-background.JPG"));
				shell.open();
				shell.setFocus();
				   while (!shell.isDisposed()) {
				    
				      if (!Display.getCurrent().readAndDispatch()) {
				    	  Display.getCurrent().sleep();
				       
				        
				      }
				    }
				
			} catch (Exception e) {
				
				e.printStackTrace();
			}
	       
	        
			
		}
		else
		{
			try {
				String server ;
//				 if(server.indexOf(":")!=-1)
//			    	 server = server.substring(0,server.indexOf(":"));
				
					// Display the Error Message
					MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_INFORMATION);
				
					mProjectError.setMessage(ReqProDriverResourceBundle.getString("BROWSERHELP"));
					mProjectError.open();
					
				
					// temp modification
				
					server = sBaseHelpURL.replaceFirst("<Server Info>", serverText.getText());
					// server = server + "/";
	//				 
					String sHelp = "rundll32 url.dll,FileProtocolHandler " + server;
					Runtime.getRuntime().exec(sHelp);
				
			} catch (IOException e) {
				
				// Display the Error Message
				MessageBox mProjectError = new MessageBox(Display.getCurrent().getActiveShell(),SWT.ICON_ERROR);
			
				mProjectError.setMessage(ReqProDriverResourceBundle.getString(ReqProDriverResourceBundle.getString("BROWSERERROR")));
				mProjectError.open();
				
			}
		}
		
	}
	/**
	 * This method initializes combo	
	 *
	 */
	private void createCombo() {
		projectListCombo = new Combo(this, SWT.NONE);
		projectListCombo.setText(ReqProDriverResourceBundle.getString("PROJECTSELECT"));
		projectListCombo.setBounds(new Rectangle(106, 172, 241, 16));
		projectListCombo.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("widgetSelected()"); 
				sSelectedItem1 = projectListCombo.getText();
				if(checkAllItems != null)
				{
					iFlag_Initialize = 1;
					disableConrols();
					projectListCombo.setEnabled(true);
					userNameText.setEnabled(true);
					passwordText.setEnabled(true);
					projectButton.setEnabled(true);
				}
				
				
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		//comboViewer = new ComboViewer(combo);
	}

	/**
	 * This method initializes combo1	
	 *
	 */
	private void createCombo1() {
		projectItemCombo = new Combo(this, SWT.NONE);
		projectItemCombo.setText(ReqProDriverResourceBundle.getString("PLEASESELECTPROJECTITEM"));
		projectItemCombo.setBounds(new Rectangle(106, 314, 256, 16));
		projectItemCombo.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("widgetSelected()"); 
				sSelectedItem2 = projectItemCombo.getText();
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		
	}

	/**
	 * This method initializes group	
	 *
	 */
	private void createGroup() {
		group = new Group(this, SWT.NONE);
		group.setLayout(new GridLayout());
		group.setText(ReqProDriverResourceBundle.getString("SERVER"));
		group.setBounds(new Rectangle(0, 1, 512, 122));
	}

	/**
	 * This method initializes group1	
	 *
	 */
	private void createGroup1() {
		group1 = new Group(this, SWT.NONE);
		group1.setLayout(null);
		group1.setText(ReqProDriverResourceBundle.getString("PROJECT"));
		group1.setBounds(new Rectangle(0, 148, 510, 120));
		projectLoginErrLabel = new Label(group1, SWT.NONE);
		projectLoginErrLabel.setText("");
		projectLoginErrLabel.setBounds(new Rectangle(273, 59, 224, 46));
		projectLoginErrLabel.setVisible(false);
	}

	/**
	 * This method initializes group2	
	 *
	 */
	private void createGroup2() {
		group2 = new Group(this, SWT.NONE);
		group2.setLayout(new GridLayout());
		group2.setText(ReqProDriverResourceBundle.getString("PROJECTITEMS"));
		group2.setBounds(new Rectangle(0, 285, 511, 76));
	}

	/**
	 * This method initializes group3	
	 *
	 */
	private void createGroup3() {
		group3 = new Group(this, SWT.NONE);
		group3.setLayout(new GridLayout());
		group3.setText(ReqProDriverResourceBundle.getString("EXPLORER"));
		group3.setBounds(new Rectangle(0, 375, 511, 271));
	}

	/**
	 * This method initializes group4	
	 *
	 */
	private void createGroup4() {
		group4 = new Group(this, SWT.NONE);
		group4.setLayout(new GridLayout());
		group4.setText(ReqProDriverResourceBundle.getString("FILTERS"));
		group4.setBounds(new Rectangle(0, 660, 511, 91));
	}

}  

//

//====================================================== XML Parser ==============================================================
final class RDS_xmlparser
{
		
	 public static void  parse(InputStream filename) throws Exception {
		    SAXParserFactory factory = SAXParserFactory.newInstance();
		    RDS_XMLIconTreeHandler handler = new RDS_XMLIconTreeHandler();
		    SAXParser saxParser = factory.newSAXParser();
				
		   // Clear the tree before parsing 
		    if(RESTDataSource.iLoadingFlag == 1)
		    {
		    	RESTDataSource.tree.removeAll();
		    	RESTDataSource.iLoadingFlag = -1;
		    	
		    }
		    saxParser.parse(filename, handler);
		   
		  }
}

//====================================================== Parser Handler ============================================================

final class RDS_XMLIconTreeHandler extends DefaultHandler {
	
	String itemUrl = null ;	
	public  TreeItem node_Parent = null;
	private  String eName = null;	

	
	private HashMap mNode_ID = new HashMap();
	
	
	// Pkg information - Name and Key
	private String sPackageKey = "";
	private String sPackageName = "";
	
	private int iFlag_Done = -1;
    
    public void startElement(String namespaceURI, String lName, String qName, Attributes attrs)
        throws SAXException {
      eName = lName;
      if ("".equals(eName))
        eName = qName;
      
      //System.out.println("Node Name : "+ eName);
      
      //======================  Handle the Projects List ========================
      if(RESTDataSource.iFlag_Process == RESTDataSource.iProject)
      {
    	
    	  // Format of Project List XML
    	  //    	  -<Projects>
    	  //    	  	<Project Name="Learning Project - Use Cases"/>
    	  //    	  	<Project Name="Learning Project - Traditional"/>
    	  //    	  </Projects>
    	  
    	  if(eName.equalsIgnoreCase("Project"))
        	  {
        		  for (int i = 0; i < attrs.getLength(); i++) {
      	  	        String aname = attrs.getQName(i);
      	  	        String value = attrs.getValue(i);
      	  	        
      	  	        if(aname.equalsIgnoreCase("Name"))
      	  	        {
      	  	        	
      	  	        	String sProjectName = value;
      	  	        	RESTDataSource.projectListCombo.add(sProjectName) ;
      	  	        	//value += "?fields=*/*/*/*/*";
      	  	        	RESTDataSource.projectListCombo.setData(sProjectName,value);
      	  	        	
      	  	        	//System.out.println("Project  : "+ sProjectName);
      	  	        }
      	    	  }
        		  	
        		  
        	  }
//    	  
    	  
    	  
      }
      
      
      //========================= Handle the Project Items ==========================
      
      else if(RESTDataSource.iFlag_Process == RESTDataSource.iProjectItems)
      {

    	  
    	  // Authentication Successful
    	  // Update the project items combobox with the report items
    	  
    	  if((eName.equalsIgnoreCase("Project")))
    	  {
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("PROJECT")) ;
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("PACKAGES")) ;
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("REQUIREMENTS")) ;
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("DOCUMENTS")) ;
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("PROJECTSTRUCTURE")) ;
    		  RESTDataSource.projectItemCombo.add(ReqProDriverResourceBundle.getString("PROJECTSECURITY")) ;
    		  
    	  }
    	  
      }
      
      //==================== Reporting on Requirements ==============================
      else if(RESTDataSource.iFlag_Process == RESTDataSource.iRequirements )
      {
   	  
    	  
    	  // Build the Package Hierarchy using the package explorer URL
    	  if(eName.equalsIgnoreCase("ParentPackage"))
        	  {
    		  	 
        	  	  // Loop through attributes to get the Name and ID of the package
        	  	  for (int i = 0; i < attrs.getLength(); i++) {
    	  	        String aname = attrs.getQName(i);
    	  	        String value = attrs.getValue(i);
    	  	        
    	  	        if(aname.equalsIgnoreCase("Key"))
    	  	        {
    	  	        	sPackageKey = value;
    	  	        }
    	  	        else if(aname.equalsIgnoreCase("Name"))
    	  	        {
    	  	        	sPackageName = value;
    	  	        }
    	    	  }
        	  	 
        	  	// Create the Node only if the node is not already present
    		  	  
        		if(mNode_ID.get(sPackageKey) == null)
        	  	{
	        	  	// iFlag_RootNode = 2 ;
	        	  	  TreeItem treeNode = new TreeItem(RESTDataSource.tree,0);
	        	  	  treeNode.setText(sPackageName);
	    	    	  node_Parent = treeNode;
	    	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/folder_c.gif"));
	    	    	  treeNode.setData("Type","Package");
	    	    	  
	    	    	  // save the node information
        	  	}
        	  	else
        	  	{
        	  		node_Parent = (TreeItem) mNode_ID.get(sPackageKey);
        	  	}
	    	    	  
    	    	  
        	  }
    	  
    	  if(eName.equalsIgnoreCase("Package"))
    	  {
		  	  String sKey = "";
		  	  String sPkgName = "";
    		  TreeItem treeNode = new TreeItem(node_Parent,0);
    	  	  
    	  	  // Loop through attributes to get the Name and ID of the package
    	  	  for (int i = 0; i < attrs.getLength(); i++) {
	  	        String aname = attrs.getQName(i);
	  	        String value = attrs.getValue(i);
	  	        
	  	        if(aname.equalsIgnoreCase("Key"))
	  	        {
	  	        	sKey = value;
	  	        }
	  	        else if(aname.equalsIgnoreCase("Name"))
	  	        {
	  	        	sPkgName = value;
	  	        }
	    	  }
    	  	  treeNode.setText(sPkgName);
	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/folder_c.gif"));
	    	  treeNode.setData("Type","Package");
	    	  
	    	  // save the node
	    	  mNode_ID.put(sKey, treeNode);
	    	
	    	  
    	  }
    	  if(eName.equalsIgnoreCase("View"))
    	  {
    		  String sKey = "";
		  	  String sPkgName = "";
    		  TreeItem treeNode = new TreeItem(node_Parent,0);
    	  	  
    	  	  // Loop through attributes to get the Name and ID of the package
    	  	  for (int i = 0; i < attrs.getLength(); i++) {
	  	        String aname = attrs.getQName(i);
	  	        String value = attrs.getValue(i);
	  	        
	  	        if(aname.equalsIgnoreCase("Key"))
	  	        {
	  	        	sKey = value;
	  	        }
	  	        else if(aname.equalsIgnoreCase("Name"))
	  	        {
	  	        	sPkgName = value;
	  	        }
	    	  }
    	  	  treeNode.setText(sPkgName);
	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/att_mtrx_v.gif"));
	    	  treeNode.setData("Type","View");
	    	  treeNode.setData("ID",sKey);
	    	  
	    	// Store all the IDs for the option of Report on all Views
	    	  RESTDataSource.sIDList = RESTDataSource.sIDList + "," + sKey; 
	    	 
    	  }
    	 
      
      }
      
      // ======================  Reporting on Documents ==========================
         
      else if(RESTDataSource.iFlag_Process == RESTDataSource.iReqDocuments)
      {
    	  
    	// Build the Package Hierarchy using the package explorer URL
    	  if(eName.equalsIgnoreCase("ParentPackage"))
        	  {
    		  	 
        	  	  // Loop through attributes to get the Name and ID of the package
        	  	  for (int i = 0; i < attrs.getLength(); i++) {
    	  	        String aname = attrs.getQName(i);
    	  	        String value = attrs.getValue(i);
    	  	        
    	  	        if(aname.equalsIgnoreCase("Key"))
    	  	        {
    	  	        	sPackageKey = value;
    	  	        }
    	  	        else if(aname.equalsIgnoreCase("Name"))
    	  	        {
    	  	        	sPackageName = value;
    	  	        }
    	    	  }
        	  	 
        	  	// Create the Node only if the node is not already present
    		  	  
        		if(mNode_ID.get(sPackageKey) == null)
        	  	{
	        	  	// iFlag_RootNode = 2 ;
	        	  	  TreeItem treeNode = new TreeItem(RESTDataSource.tree,0);
	        	  	  treeNode.setText(sPackageName);
	    	    	  node_Parent = treeNode;
	    	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/doc_folder.gif"));
	    	    	  treeNode.setData("Type","Package");
	    	    	  
	    	    	  // save the node information
        	  	}
        	  	else
        	  	{
        	  		node_Parent = (TreeItem) mNode_ID.get(sPackageKey);
        	  	}
	    	    	  
    	    	  
        	  }
    	  
    	  if(eName.equalsIgnoreCase("Package"))
    	  {
		  	  String sKey = "";
		  	  String sPkgName = "";
    		  TreeItem treeNode = new TreeItem(node_Parent,0);
    	  	  
    	  	  // Loop through attributes to get the Name and ID of the package
    	  	  for (int i = 0; i < attrs.getLength(); i++) {
	  	        String aname = attrs.getQName(i);
	  	        String value = attrs.getValue(i);
	  	        
	  	        if(aname.equalsIgnoreCase("Key"))
	  	        {
	  	        	sKey = value;
	  	        }
	  	        else if(aname.equalsIgnoreCase("Name"))
	  	        {
	  	        	sPkgName = value;
	  	        }
	    	  }
    	  	  treeNode.setText(sPkgName);
	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/doc_folder.gif"));
	    	  treeNode.setData("Type","Package");
	    	  
	    	  // save the node
	    	  mNode_ID.put(sKey, treeNode);
	    	
	    	  
    	  }
    	  if(eName.equalsIgnoreCase("Document"))
    	  {
    		  String sKey = "";
		  	  String sPkgName = "";
    		  TreeItem treeNode = new TreeItem(node_Parent,0);
    	  	  
    	  	  // Loop through attributes to get the Name and ID of the package
    	  	  for (int i = 0; i < attrs.getLength(); i++) {
	  	        String aname = attrs.getQName(i);
	  	        String value = attrs.getValue(i);
	  	        
	  	        if(aname.equalsIgnoreCase("Key"))
	  	        {
	  	        	sKey = value;
	  	        }
	  	        else if(aname.equalsIgnoreCase("Name"))
	  	        {
	  	        	sPkgName = value;
	  	        }
	    	  }
    	  	  treeNode.setText(sPkgName);
	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/word.gif"));
	    	  treeNode.setData("Type","Document");
	    	  treeNode.setData("ID",sKey);
	    	  
	    	  // Store all the IDs for the option of Report on all Documents
	    	  RESTDataSource.sIDList = RESTDataSource.sIDList + "," + sKey;
	    	 
    	  }
    	 
      
      }
      
     
      // ====================== Reporting on Packages ==========================================
      
      else if(RESTDataSource.iFlag_Process == RESTDataSource.iPackages )
      {

    	// Build the Package Hierarchy using the package explorer URL
    	  if(eName.equalsIgnoreCase("ParentPackage"))
        	  {
    		  	 
        	  	  // Loop through attributes to get the Name and ID of the package
        	  	  for (int i = 0; i < attrs.getLength(); i++) {
    	  	        String aname = attrs.getQName(i);
    	  	        String value = attrs.getValue(i);
    	  	        
    	  	        if(aname.equalsIgnoreCase("Key"))
    	  	        {
    	  	        	sPackageKey = value;
    	  	        }
    	  	        else if(aname.equalsIgnoreCase("Name"))
    	  	        {
    	  	        	sPackageName = value;
    	  	        }
    	    	  }
        	  	 
        	  	// Create the Node only if the node is not already present
    		  	  
        		if(mNode_ID.get(sPackageKey) == null)
        	  	{
	        	  	// iFlag_RootNode = 2 ;
	        	  	  TreeItem treeNode = new TreeItem(RESTDataSource.tree,0);
	        	  	  treeNode.setText(sPackageName);
	    	    	  node_Parent = treeNode;
	    	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/folder_c.gif"));
	    	    	  treeNode.setData("Type","Package");
	    	    	  treeNode.setData("ID",sPackageKey);
	    	    	  
	    	    	  // save the node information
        	  	}
        	  	else
        	  	{
        	  		node_Parent = (TreeItem) mNode_ID.get(sPackageKey);
        	  	}
	    	    	  
    	    	  
        	  }
    	  
    	  if(eName.equalsIgnoreCase("Package"))
    	  {
		  	  String sKey = "";
		  	  String sPkgName = "";
    		  TreeItem treeNode = new TreeItem(node_Parent,0);
    	  	  
    	  	  // Loop through attributes to get the Name and ID of the package
    	  	  for (int i = 0; i < attrs.getLength(); i++) {
	  	        String aname = attrs.getQName(i);
	  	        String value = attrs.getValue(i);
	  	        
	  	        if(aname.equalsIgnoreCase("Key"))
	  	        {
	  	        	sKey = value;
	  	        }
	  	        else if(aname.equalsIgnoreCase("Name"))
	  	        {
	  	        	sPkgName = value;
	  	        }
	    	  }
    	  	  treeNode.setText(sPkgName);
	    	  treeNode.setImage(ReqProUIActivator.getImage("icons/folder_c.gif"));
	    	  treeNode.setData("Type","Package");
	    	  treeNode.setData("ID",sKey);
	    	  // save the node
	    	  mNode_ID.put(sKey, treeNode);
	    	
	    	  
    	  }
    	 
      
      }
      
      // Reporting on Project Structure
//      else if(RESTDataSource.iFlag_Process == RESTDataSource.iProjectStructure)
//      {
//    	  if (iFlag_Done == -1) {
//			TreeItem treeNode = new TreeItem(RESTDataSource.tree, 0);
//			treeNode
//					.setText("--Please Click the Button \"Generate URL\" to generate the URL");
//			//node_Parent = treeNode;
//			treeNode.setImage(ReqProUIActivator.getImage("icons/reqpro.gif"));
//			treeNode.setData("Type", "Project Structure");
//			iFlag_Done = 1;
//		}
//    	  
//      }
      
   // Reporting on Project Security
//      else if(RESTDataSource.iFlag_Process == RESTDataSource.iProjectSecurity)
//      {
//    	  if (iFlag_Done == -1) {
//			TreeItem treeNode = new TreeItem(RESTDataSource.tree, 0);
//			treeNode
//					.setText("--Please Click the Button \"Generate URL\" to generate the URL");
//			//node_Parent = treeNode;
//			treeNode.setImage(ReqProUIActivator.getImage("icons/reqpro.gif"));
//			treeNode.setData("Type", "Project Security");
//			iFlag_Done = 1;
//		}
//    	  
//    	  
//      }
      else
      {
    	  
    	  // ============================ Reporting on all Elements Completed =====================
    	  
 
      }
	    	 
	    	  
    }

    public void endElement(String namespaceURI, String sName, String qName) throws SAXException {
        String eName = sName;
        if ("".equals(eName))
          eName = qName;
        
        //System.out.println("eName <End Element> :" + eName);
        
               
        // REST Specific Implementations
        if(eName.equalsIgnoreCase("rqipos_stream"))
        {
        	
        	node_Parent = null;
        	RESTDataSource.sIDList.replaceFirst(",", "");
        
        	
        }
        if(eName.equalsIgnoreCase("PROJECT"))
        {
        	iFlag_Done = -1;
        	
        }
        // Clear the package from the Map once its processed
        if(eName.equalsIgnoreCase("ParentPackage"))
        {
        	// Remove the entry
        	mNode_ID.remove(sPackageKey);
        	
        }
        
    	
    }
    
    public void characters(char ch[] , int start, int length) throws SAXException
    {
    	String s = new String(ch,start,length).trim();
    	//System.out.println("Node value : "+ s);
    	
    }
  }
